unit LogU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ActnList, ComCtrls, StdCtrls, ToolWin, StdActns, Spin,
  ExtCtrls;

type
  TLogsF = class(TForm)
    ToolBar1: TToolBar;
    LogsLB: TListBox;
    StatusB: TStatusBar;
    ActionL: TActionList;
    ImageL: TImageList;
    ToolButton2: TToolButton;
    ToolButton1: TToolButton;
    FileSaveAs1: TFileSaveAs;
    ToolButton3: TToolButton;
    StartStopA: TAction;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    Panel1: TPanel;
    ToolButton7: TToolButton;
    Label1: TLabel;
    MaxLinesSE: TSpinEdit;
    CloseA: TAction;
    ToolButton6: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ClearA: TAction;
    procedure StartStopAExecute(Sender: TObject);
    procedure CloseAExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileSaveAs1BeforeExecute(Sender: TObject);
    procedure FileSaveAs1Accept(Sender: TObject);
    procedure ClearAExecute(Sender: TObject);
    procedure FileSaveAs1Cancel(Sender: TObject);
  private
    FStarted: boolean;
    TmpIsStarted : boolean;
    procedure SetStarted(const Value: boolean);
  public
    procedure LogAdd( LS : string);
    property Started : boolean read FStarted write SetStarted;
  end;

var
  LogsF: TLogsF;

implementation

{$R *.dfm}

procedure TLogsF.FormCreate(Sender: TObject);
begin
  FStarted := false; Started := true;
end;

procedure TLogsF.FormDestroy(Sender: TObject);
begin
{}
end;

procedure TLogsF.StartStopAExecute(Sender: TObject);
begin
  StartStopA.Checked := NOT StartStopA.Checked;
  if StartStopA.Checked then begin
    StartStopA.ImageIndex := 2;
    StartStopA.Hint := 'Stop logging';
    end
  else begin
    StartStopA.ImageIndex := 1;
    StartStopA.Hint := 'Start logging';
    end;
  Started := StartStopA.Checked;
end;

procedure TLogsF.CloseAExecute(Sender: TObject);
begin Close; end;

procedure TLogsF.LogAdd(LS: string);
begin
  if NOT Started then exit;
  if LogsLB.Items.Count > MaxLinesSE.Value then begin
    while LogsLB.Items.Count > MaxLinesSE.Value do LogsLB.Items.Delete( 0);
    end;
  LogsLB.Items.Add( LS);
  LogsLB.ItemIndex := LogsLB.Items.Count - 1;
  StatusB.Panels[ 0].Text := 'Lines: ' + IntToStr( LogsLB.Items.Count);
end;

procedure TLogsF.SetStarted(const Value: boolean);
begin
  if FStarted = Value then exit;
  FStarted := Value;
end;

procedure TLogsF.FileSaveAs1BeforeExecute(Sender: TObject);
begin
  TmpIsStarted := Started;
  if Started then StartStopA.Execute; // Stop
end;

procedure TLogsF.FileSaveAs1Accept(Sender: TObject);
begin
  LogsLB.Items.SaveToFile( FileSaveAs1.Dialog.FileName);
  if TmpIsStarted then StartStopA.Execute; // Start
end;

procedure TLogsF.FileSaveAs1Cancel(Sender: TObject);
begin
  if TmpIsStarted then StartStopA.Execute; // Start
end;

procedure TLogsF.ClearAExecute(Sender: TObject);
begin
  TmpIsStarted := Started;
  if Started then StartStopA.Execute; // Stop
  LogsLB.Items.Clear;
  StatusB.Panels[ 0].Text := '';
  if TmpIsStarted then StartStopA.Execute; // Start
end;

end.
