unit About;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    DateL: TLabel;
    BitBtn1: TBitBtn;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    VersionL: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ZarkoSiteLClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation
{$R *.DFM}
uses ShellAPI, SysUtils;

// get application file version ID (if included)
function GetAppFileVersion : string;
var
  iBufferSize, iDummy: DWORD;
  pBuffer: Pointer;
  pFileInfo: Pointer;
  iVer: Array[1..4] of Word;
  FileName : string;
begin
  // set default value
  Result := '';

  FileName := Application.ExeName;

  // get size of version info (0 if no version info exists)
  iBufferSize := GetFileVersionInfoSize(PChar(FileName), iDummy);
  if (iBufferSize > 0) then
  begin
    GetMem(pBuffer, iBufferSize);
    try
    // get fixed file info
    GetFileVersionInfo(PChar(FileName), 0, iBufferSize, pBuffer);
    VerQueryValue(pBuffer, '\', pFileInfo, iDummy);
    // read version blocks
    iVer[1] := HiWord(PVSFixedFileInfo(pFileInfo)^.dwFileVersionMS);
    iVer[2] := LoWord(PVSFixedFileInfo(pFileInfo)^.dwFileVersionMS);
    iVer[3] := HiWord(PVSFixedFileInfo(pFileInfo)^.dwFileVersionLS);
    iVer[4] := LoWord(PVSFixedFileInfo(pFileInfo)^.dwFileVersionLS);
    finally
      FreeMem(pBuffer);
    end;
    // format result string
    Result := Format('%d.%d.%d.%d', [iVer[1], iVer[2], iVer[3], iVer[4]]);
  end;
end;


procedure TAboutBox.FormCreate(Sender: TObject);
begin
  ProgramIcon.Picture.Graphic := Application.Icon;
  VersionL.Caption := GetAppFileVersion;
end;

procedure TAboutBox.SpeedButton2Click(Sender: TObject);
begin
  ShellExecute( 0, Nil, 'www.kochini.com', Nil, Nil, SW_NORMAL);
end;

procedure TAboutBox.SpeedButton1Click(Sender: TObject);
begin
  ShellExecute( 0, Nil, 'mailto:contact@kochini.com', Nil, Nil, SW_NORMAL);
end;

procedure TAboutBox.ZarkoSiteLClick(Sender: TObject);
begin
  ShellExecute( 0, Nil, 'http://delphi.about.com/', Nil, Nil, SW_NORMAL);
end;

end.

